
namespace IRDB_SDK
{

	using namespace std;

	class File_t : virtual public BaseObj_t
	{
		protected:
			File_t() { };
			File_t(const File_t& copy) = delete;
		public:
			virtual ~File_t() { };

			virtual string       getAddressTableName()     const = 0;
			virtual string       getFunctionTableName()    const = 0;
			virtual string       getInstructionTableName() const = 0;
			virtual string       getICFSTableName()        const = 0;
			virtual string       getICFSMapTableName()     const = 0;
			virtual string       getRelocationsTableName() const = 0;
			virtual string       getTypesTableName()       const = 0;
			virtual string       getScoopTableName()       const = 0;
			virtual string       getEhProgramTableName()   const = 0;
			virtual string       getEhCallSiteTableName()  const = 0;
			virtual string       getURL()                  const = 0;
			virtual int          getELFOID()               const = 0;
			virtual DatabaseID_t getFileID()               const = 0;

	};

}
