namespace IRDB_SDK
{

	using namespace std;

	class ICFS_t : virtual public InstructionSet_t, virtual public BaseObj_t
	{
		protected:
			ICFS_t() {};
			ICFS_t(const ICFS_t& copy) = delete;
		public:
			 
			// getters
			virtual bool                 isIncomplete()      const = 0;
			virtual bool                 isComplete()        const = 0;
			virtual bool                 isModuleComplete()  const = 0;
			virtual ICFSAnalysisStatus_t getAnalysisStatus() const = 0;

			// mutators
			virtual void setTargets(const InstructionSet_t &other)              = 0;
			virtual void addTargets(const InstructionSet_t &other)              = 0;
			virtual void setAnalysisStatus(const ICFSAnalysisStatus_t p_status) = 0;

	};

}
