
namespace IRDB_SDK
{

	class IBTProvenance_t
	{

		public:
			IBTProvenance_t() {}
			IBTProvenance_t(const IBTProvenance_t& copy) = delete;
		public:

			virtual ~IBTProvenance_t() {} 	

			static unique_ptr<IBTProvenance_t> factory(const FileIR_t* f=NULL); 

			virtual const Provenance_t& getProvenance(const Instruction_t* i)  const = 0 ;
			virtual const Provenance_t& operator[] (const Instruction_t* i)    const = 0 ;
	 

	};

}

